{-----------------------------------------------------------------------------}
{   Code source  utilis dans la leon 4 du Guide Pratique de
{   la programmation de directshow sous delphi publi par Paul Glagla
{   sur le site http://paul.glagla.free.fr
{
{-----------------------------------------------------------------------------}
unit ConvertirDVunit;

{-----------------------------------------------------------------------------}
interface

{-----------------------------------------------------------------------------}
uses
  SysUtils, Classes, DSPack,DSUtil,directshow9;

{-----------------------------------------------------------------------------}
type
  Tdm = class(TDataModule)
    FilterGraph1: TFilterGraph;
    source: TFilter;
    destination: TFilter;
    avisplitter: TFilter;
    dvmuxer: TFilter;
    avimux: TFilter;
    dvsplitter: TFilter;
    procedure DataModuleDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  function buildgraphDV2to1(type2,type1:string):Boolean;
  function buildgraphDV1to2(type1,type2:string):Boolean;
end;

{-----------------------------------------------------------------------------}
var
  dm: Tdm;

{-----------------------------------------------------------------------------}
implementation

uses main;

{$R *.dfm}
{-----------------------------------------------------------------------------}
function Tdm.buildgraphDV2to1(type2,type1:string):Boolean;
var   buffer1,buffer2:array[0..255]of widechar;
      wtype1,wtype2:pwidechar;
      sourcepl,avisplitterpl,dvmuxerpl,avimuxpl,destinationpl:TPinlist;
{On dclare pour chacun des 5 filtres de notre graphe, une variable de type TPinList qui listera tous les pins du filtre.
Attention, la classe TPinlist est dclare dans DSUtil, qu'il faut donc ajouter  la clause Uses de votre unit.}
 
    begin
        result:=False;
    try
        wtype2:=stringtowidechar(type2,buffer2,255);
        wtype1:=stringtowidechar(type1,buffer1,255);
        filtergraph1.Active:=true;
        (source as IFileSourceFilter).load(wtype2,nil);
        (destination as IFileSinkFilter2).SetFileName(wtype1,nil);
    except
        exit;
    end;
{C'est en substance  le code que nous avions dj crit plus haut, sauf que result:=True sera renvoy plus loin pour
n'intervenir que quand le graphe complet a pu tre construit.}
 
// crer les listes de pins de chaque filtre
    try
        sourcepl:=TPinlist.create(source as IBaseFilter);
        avisplitterpl:=TPinlist.create(avisplitter as IBaseFilter);
        dvmuxerpl:=TPinlist.create(dvmuxer as IBaseFilter);
        avimuxpl:=TPinlist.create(avimux as IBaseFilter);
        destinationpl:=TPinlist.create(destination as IBaseFilter);
{Ici on cre chacun des Tpinlist  partir du filtre correspondant. Notez que IBaseFIlter est une nouvelle interface qu'il faut
mobiliser sur nos filtres pour les utiliser dans le constructeur de TPinList. }
 
// connecter les pins
    try
        sourcepl[0].Connect(avisplitterpl[0],nil);
        avisplitterpl.Update;
        avisplitterpl[0].Connect(dvmuxerpl[0],nil);
        dvmuxerpl.Update;
        avisplitterpl[1].Connect(dvmuxerpl[1],nil);
        dvmuxerpl.update;
        dvmuxerpl[3].Connect(avimuxpl[1],nil);
        avimuxpl[0].Connect(destinationpl[0],nil);
        result:=True;
    except
    end;
{C'est le coeur de notre fonction, o nous connectons un par un les pins souhaits, en les prenant par leur numro dans
la pinlist correspondante. Deux lments rendent cette partie assez difficile, et font qu'il y a souvent besoin de 
ttonnements, qui peuvent tre aids par un recours  GraphEdit. Le premier lment difficile est que l'on ne sait pas a 
priori quel est le numro du pin qui nous intresse. Il faut essayer, vrifier avec GraphEdit (et acqurir un peu de jugeotte 
par l'exprience). La deuxime difficult est que certains filtres crent des pins seulement aprs que les pins prcdents 
aient t connects. C'est typiquement le cas de Avi Splitter, qui au dpart n'a qu'un pin d'entre, et qui cre autant de 
pins de sortie qu'il y a de streams une fois la connexion tablie. D'o le rle de la mthode update, qui remet  jour la 
liste des pins, pour pouvoir dsigner les derniers pins crs.}
 
// dtruire les listes de pin
    finally
        destinationpl.Free;
        avimuxpl.Free;
        dvmuxerpl.Free;
        avisplitterpl.Free;
        sourcepl.Free;
    end;
         
    end;
{ Une fois toutes les connexions tablies, on peut dtruire les listes de pins.}
 {-----------------------------------------------------------------------------}
function Tdm.buildgraphDV1to2(type1,type2:string):Boolean;
var   buffer1,buffer2:array[0..255]of widechar;
      wtype1,wtype2:pwidechar;
      sourcepl,avisplitterpl,dvsplitterpl,avimuxpl,destinationpl:TPinlist;

    begin
        result:=False;
    try

        wtype1:=stringtowidechar(type1,buffer1,255);
        wtype2:=stringtowidechar(type2,buffer2,255);
        filtergraph1.active:=false;;
        filtergraph1.Active:=true;
        (source as IFileSourceFilter).load(wtype1,nil);
        (destination as IFileSinkFilter2).SetFileName(wtype2,nil);
    except
        exit;
    end;

// crer les listes de pin de chaque filtre
    try
        sourcepl:=TPinlist.create(source as IBaseFilter);
        avisplitterpl:=TPinlist.create(avisplitter as IBaseFilter);
        dvsplitterpl:=TPinlist.create(dvsplitter as IBaseFilter);
        avimuxpl:=TPinlist.create(avimux as IBaseFilter);
        destinationpl:=TPinlist.create(destination as IBaseFilter);

// connecter les pins
    try
        sourcepl[0].Connect(avisplitterpl[0],nil);
        avisplitterpl.Update;
        avisplitterpl[0].Connect(dvsplitterpl[0],nil);
        dvsplitterpl.Update;
        dvsplitterpl[1].Connect(avimuxpl[1],nil);
        avimuxpl.update;
        dvsplitterpl[2].Connect(avimuxpl[2],nil);
        avimuxpl[0].Connect(destinationpl[0],nil);
        result:=true
    except
    end;
// dtruire les listes de pin
  finally
        destinationpl.Free;
        avimuxpl.Free;
        dvsplitterpl.Free;
        avisplitterpl.Free;
        sourcepl.Free;
  end;
end;

{-----------------------------------------------------------------------------}
procedure Tdm.DataModuleDestroy(Sender: TObject);
begin
filtergraph1.cleargraph;
filtergraph1.active:=false;

end;

end.
